#!/bin/sh

Result=1

# RemoveDir
RemoveDir()
{
	target="$1"
	if [ -d "${target}" ]
	then
		/bin/rm -R "${target}"
		ret=$?
		if [ $ret -eq 0 ]
		then
			Result=0
		else
			echo "Failed to remove ${target}"
			return 1
		fi
	else
		echo "Not found ${target}"
		return 1
	fi
	return 0
}

RemoveDirIfEmpty()
{
	target="$1"
	if [ -d "${target}" ]
	then
		search=`/bin/ls -A "$1" 2> /dev/null`
		if [ -z "${search}" -o "${search}" = ".DS_Store" ]
		then
			/bin/rm -R "${target}"
			ret=$?
			if [ $ret -ne 0 ]
			then
				echo "Failed to remove ${target}"
				return 1
			fi
		fi
	else
		echo "Not found ${target}"
		return 1
	fi
	return 0
}

# RemoveFile
RemoveFile()
{
	target="$1"
	if [ -f "${target}" ]
	then
		/bin/rm -R "${target}"
		ret=$?
		if [ $ret -eq 0 ]
		then
			Result=0
		else
			echo "Failed to remove ${target}"
			return 1
		fi
	else
		echo "Not found ${target}"
		return 1
	fi
	return 0
}

# USB Audio Driver
RemoveDir "/System/Library/Extensions/ZOOM R16USBAudio.kext"
RemoveDir "/Library/Extensions/ZOOM R16USBAudio.kext"

# USB MIDI Driver
RemoveDir "/Library/Audio/MIDI Drivers/ZOOM R16USBMidi.plugin"

# MIDI device image file
RemoveFile "/Library/Audio/MIDI Devices/ZOOM/Images/R16.tiff"
RemoveDirIfEmpty "/Library/Audio/MIDI Devices/ZOOM/Images"
RemoveDirIfEmpty "/Library/Audio/MIDI Devices/ZOOM"

# Control Panel
RemoveDir "/Library/PreferencePanes/ZOOM R16ControlPanel.prefPane"

# Device Manager
RemoveDir "/Library/Application Support/ZOOM/R16/ZOOM R16DeviceManager.app"
RemoveDirIfEmpty "/Library/Application Support/ZOOM/R16"
RemoveDirIfEmpty "/Library/Application Support/ZOOM"

# LaunchAgents info file
RemoveFile "/Library/LaunchAgents/com.zoom.R16DeviceManager.plist"

# Installer in Receipts
RemoveDir "/Library/Receipts/ZOOM R16Driver.pkg"

exit ${Result}
